#!/usr/bin/perl
#
# A random pseudo-Japanese name generator
# ancestral
# From thw Wesnoth forums
# Last updated 5 Mar 09
#
# This file is released under CC-by-3.0. You may use this however you wish as long as you attribute me as the original author. Thanks.

my @letters = qw (a a ba be bi bo bu cha chi cho chu da de do e e fu ga ge gi go gu ha he hi hi ho i ja ji ji jo ju ka ka ke ke ko ki ko ko kyo ku ma me mi mi mo mu n n n na ne ni no nu o o ra re ri ri ro ru ru ryo sa se sha shi shi sho shu so su tsu tsu ta ta te to to u u wa wa ya yo yo yu za ze zo zu);

my @letters = qw (a a a a ba bi bu be bo bo da da da da ji ji ji ju de de do do do jo jo e e e e fa fa fu fu fu fu ga ga ga ga gi gi gu ge ge go go go go ha ha ha ha ha hi hi hi hi hi hu he ho i i i ka ka ka ka ki ki ki ki ki ki ku ku kyu ke ke ke ko ko ko ko ko kyo ma ma ma ma mi mi mi mi mu mu me me mo mo mo mo n n n n n na na ni ni nu nu ne ne ne ne no no no o o o o ra ra ri ri ri ri ru ru ru ru re re re ro ro ro ro ryu ryo ryo sa sa sa sha sha shi shi shi shi su su su su su se se so so so sho chi chi chi chi chi cho cho chu ta ta ta ta ta ta ta tsu tsu tsu tsu tsu te te te to to to to to u u u u wa wa wa wa wo ya ya ya yo yo yo yo yo yu za zu ze zo);

my $repeat = $ARGV[0];
($repeat = 40) if $repeat == null;

for ($j = 0; $j < $repeat; $j++)
{ print generate();
  print "\n";
}

print "\n";

sub generate
{
my @index = ();
my $roll = (int rand(2) + int rand(2) + 2);

$index[0] = int (rand(scalar (@letters)));

while ($letters[($index[0])] eq "n")
{ $index[0] = int (rand(scalar (@letters)));
}

for ($i = 1; $i < $roll; $i++)
{ $index[$i] = rand(scalar (@letters));
}

my $name = "";

foreach $item (@index)
{ $name .= $letters[$item];
}

$name =~ s/ee/ei/g;
$name =~ s/oo/ou/g;
$name =~ s/aa/a/g;
$name =~ s/ii/i/g;
$name =~ s/uu/u/g;

return "$name";
}

